//+------------------------------------------------------------------+
//|                                                 RenkoSynergy.mq4 |
//|                                         Copyright  2012, magft. |
//|                                                 http://indap.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, magft&ROBST3R"
#property link      "http://indap.net"

#include <WinUser32.mqh>
#include <stdlib.mqh>
#define  NL    "\n"
#define  up "Up"
#define  down "Down"
#define  none "None"
#define  buy "Buy"
#define  sell "Sell"

#define VERSION "1.06"
#define DATE    "9th March 2012"

extern string  gen="----General inputs----";
extern bool    StopTrading=false;
extern bool    TradeLong=true;
extern bool    TradeShort=true;
extern int     TakeProfit=0;
extern int     StopLoss=12;
extern bool    AutoSL=false;
extern string  TradeComment="";
extern bool    AutoMagicNumber=true;
extern int     MagicNumber=0;
extern bool    CriminalIsECN=true;
extern double  MaxSpreadAllowed=120;
 int     RetryCount = 10;//Will make this number of attempts to get around the trade context busy error.
//Hidden tp/sl inputs.
extern string  hts="----Trading options----";
extern bool    UseCloseOnColorChange=true;
extern bool    UseCloseOnMACross=false;
extern bool    UseTradeOnCurrentCandle=false;//this uses current candle instead of previous candle
extern bool    UseLastColorChangeSL=false;
extern bool    UsePreviousCandleSL=false;
extern int     PreviousCandleSLOffset=0;
extern bool    UseOpenTradeOnOppSignal=false;
extern bool    UseGrid=false;
//extern bool    UseOpenOppositeTradeOnClose=false;
extern string  ls="----Lot Sizing inputs----";
extern double  Lot=1.00;
extern int     RiskPercent = 0;//Set to zero to disable and use Lot
extern string  ls1="----Martingale inputs----";
extern bool    UseMartingale=false;
extern double  MartingaleLotMultiplier=2;
extern double  MaxLotsAllowed=0.32;
extern string  ls2="----Shake Recovery inputs----";
extern bool    UseShakeRecovery=false;
extern double  MaxLots.Allowed=0.32;

extern string  syni="----Renko----";
extern int     RenkoTF=2;//Time frame defaults to current chart 
int SynergyTF;
extern string  mai="----Moving average----";
extern bool    UseMa=true;
 int     MaTF=0;//Time frame defaults to current chart 
extern int     MaPeriod=5;
extern int     MaShift=2;//The MA Shift input
extern string  mame="Method: 0=sma; 1=ema; 2=smma;  3=lwma";
extern int     MaMethod=1;
extern string  maap="Applied price: 0=Close; 1=Open; 2=High";
extern string  maap1="3=Low; 4=Median; 5=Typical; 6=Weighted";
extern int     MaAppliedPrice=5;
extern int     MaBufferPips=2;
extern bool    AutoBuffer=false;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
double         MaVal;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
extern string  ma2="----Trend MA----";
extern bool    UseTrendMA=false;
 int     Ma2TF=0;//Time frame defaults to current chart 
extern int     Ma2Period=50;
extern int     Ma2Shift=0;//The MA Shift input
extern string  mame2="Method: 0=sma; 1=ema; 2=smma;  3=lwma";
extern int     Ma2Method=0;
extern string  ma2ap="Applied price: 0=Close; 1=Open; 2=High";
extern string  ma2ap1="3=Low; 4=Median; 5=Typical; 6=Weighted";
extern int     Ma2AppliedPrice=5;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
double         Ma2Val;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
extern string  amc="----Margin Check----";
extern bool    UseMarginCheck=false;
extern int     MinMarginPercent=200;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
bool           EnoughMargin;
string         MarginMessage;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

extern string  tt="----Trading hours----";
extern string  Trade_Hours= "Set Session Trading Hours";
extern string  Trade_Hoursi= "Use 24 hour, Server time";
extern bool    Trade24hr=true;
extern string  Trade_Hours_E= "Europe Session 7:00-12:00";
extern string  Start_TimeE = "07:00";
extern string  End_TimeE = "12:00";

extern string  Trade_Hours_U= "US Session 13:00-16:00";
extern string  Start_TimeU = "13:00";
extern string  End_TimeU = "16:00";

extern string  Trade_Hours_A= "Asia Session 23:00-4:00";
extern string  Start_TimeA = "23:00";
extern string  End_TimeA = "04:00";

extern string  tmm="----Trade management module----";
//Breakeven has to be enabled for JS and TS to work.
extern string  BE="Break even settings";
extern bool    BreakEven=true;
extern int     BreakEvenPips=5;
extern int     BreakEvenProfit=2;
extern string  cts="----Candlestick trailing stop----";
extern bool    UseCandlestickTrailingStop=false;
//extern int     CstTimeFrame=0;//Defaults to current chart
extern int     CstTrailCandles=2;//Defaults to previous candle
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
int            OldCstBars;//For candlestick ts
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

extern string  JSL="Jumping stop loss settings";
extern bool    JumpingStop=false;
extern int     JumpingStopPips=10;
extern bool    AddBEP=true;
extern string  TSL="Trailing stop loss settings";
extern bool    TrailingStop=false;
extern int     TrailingStopPips=20;

////////////////////////////////////////////////////////////////////////
extern string  mis="----Odds and ends----";
extern bool    ShowManagementAlerts=true;
extern string  pci="----Stats display inputs----";
extern int     FontSize=9;
extern color   PairColour=Yellow;
extern color   LongTrendColour=LimeGreen;
extern color   ShortTrendColour=Red;
extern color   RangingColour=Turquoise;
extern double  DisplayStartsAtRow=2;
extern double  RowSpacing=1;
extern double  DisplayStartsAtCol=20;
extern double  ColumnSpacing=80;
extern color   CommentBoxColor=Black;
extern color   CommentBoxColor2=DarkGray;
extern int     CommentBoxSize=140;
extern int     CommentBoxXDist=10;
extern int     CommentBoxYDist=20;

//Matt's O-R stuff
int 	         O_R_Setting_max_retries 	= 10;
double 	      O_R_Setting_sleep_time 		= 4.0; /* seconds */
double 	      O_R_Setting_sleep_max 		= 15.0; /* seconds */

//Trading variables
int            TicketNo = -1, OpenTrades;
bool           CanTradeThisPair;//Will be false when this pair fails the currency can only trade twice filter, or the balanced trade filter
bool           BuyOpen, SellOpen, PendingBuyOpen, PendingSellOpen;//Might need further refinement to reflect the pending type
double         upl;//For keeping track of the upl of hedged positions

//Synergy_APB
double         HaOpen, HaClose, HaSL, HaVal, HaVal0, HaLow, HaHigh;
string         trend,prev.trend;

//Running total of trades
int            LossTrades, WinTrades;
double         OverallProfit;

//Shake Recovery
string         GV.Cycle;

//Misc
int            OldBars;
string         PipDescription=" pips";
bool           ForceTradeClosure;
int            TurnOff=0;//For turning off functions without removing their code
int            HaStart=1;
int            multiplier=1;
string         LabelPrefix;
double         RenkoSize;

void DisplayUserFeedback()
{
   
   if (IsTesting() && !IsVisualMode()) return;
   
   ShowStats();
   
}//void DisplayUserFeedback()

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   LabelPrefix = WindowExpertName()+"-"+Symbol()+"-";

   //box
//box
   ObjectCreate("cbox", OBJ_LABEL, 0, 0, 0); ObjectSetText("cbox","g",CommentBoxSize+3,"Webdings",CommentBoxColor2);
   ObjectSet("cbox", OBJPROP_XDISTANCE, CommentBoxXDist-2); ObjectSet("cbox", OBJPROP_YDISTANCE, CommentBoxYDist-1);
   ObjectSet("cbox",OBJPROP_BACK,0); ObjectSet("cbox", OBJPROP_CORNER, 1);
   ObjectCreate("cbox2", OBJ_LABEL, 0, 0, 0); ObjectSetText("cbox2","g",CommentBoxSize,"Webdings",CommentBoxColor);
   ObjectSet("cbox2", OBJPROP_XDISTANCE, CommentBoxXDist); ObjectSet("cbox2", OBJPROP_YDISTANCE, CommentBoxYDist);
   ObjectSet("cbox2",OBJPROP_BACK,0); ObjectSet("cbox2", OBJPROP_CORNER, 1);
   ObjectCreate("cbox3", OBJ_LABEL, 0, 0, 0); ObjectSetText("cbox3","g",CommentBoxSize+3,"Webdings",CommentBoxColor2);
   ObjectSet("cbox3", OBJPROP_XDISTANCE, CommentBoxXDist-2); 
   ObjectSet("cbox3",OBJPROP_BACK,0); ObjectSet("cbox3", OBJPROP_CORNER, 1);
   ObjectCreate("cbox4", OBJ_LABEL, 0, 0, 0); ObjectSetText("cbox4","g",CommentBoxSize,"Webdings",CommentBoxColor);
   ObjectSet("cbox4", OBJPROP_XDISTANCE, CommentBoxXDist); 
   ObjectSet("cbox4",OBJPROP_BACK,0); ObjectSet("cbox4", OBJPROP_CORNER, 1);
   
   //This forces the platform to 2048 bars of data - necessary if this is a new CrapT4 installation
   iBars(NULL, Period() );
   
   //Adapt to x digit criminals
   if(Digits == 2 || Digits == 4) multiplier = 1;
   if(Digits == 3 || Digits == 5) multiplier = 10;
   if(Digits == 6) multiplier = 100;   
   if(Digits == 7) multiplier = 1000;   
   
   if (multiplier > 1) PipDescription = " points";
   
   //if (MaBufferPips<1) MaBufferPips=1;
   
   TakeProfit*= multiplier;
   StopLoss*= multiplier;
   MaBufferPips*= multiplier;
   
   BreakEvenPips*= multiplier;
   BreakEvenProfit*= multiplier;
   JumpingStopPips*= multiplier;
   TrailingStopPips*= multiplier;
   
   PreviousCandleSLOffset*=multiplier;

   //set renko tfs
   SynergyTF=RenkoTF;
   MaTF=RenkoTF;
   Ma2TF=RenkoTF;
         
   //calc bar size
   RenkoSize=NormalizeDouble(MathAbs(iOpen(Symbol(),RenkoTF,1)-iClose(Symbol(),RenkoTF,1))/Point,0);

   if (AutoSL) StopLoss=RenkoSize*2;
   if (AutoBuffer) MaBufferPips=RenkoSize;   

   if ((JumpingStop || TrailingStop) && !BreakEven) 
   {
      BreakEven = true;
      if (JumpingStop) BreakEvenPips = JumpingStopPips;
      if (TrailingStop) BreakEvenPips = TrailingStopPips;
   }//if (JumpingStop || TrailingStop) 
   
   //set magic number
   if (AutoMagicNumber) MagicNumber=_AutoMagicNumber(Symbol(),Period());   
   
   OldBars = iBars(Symbol(),RenkoTF);
   TicketNo = -1;

   //set GVs if using Shake's Recovery
   if (UseShakeRecovery)
   {
      GV.Cycle=AccountName()+"-"+Symbol()+"-"+MagicNumber+"-CycleStart";
   }
   
   //select which candle to use for ha
   if (UseTradeOnCurrentCandle) HaStart=0;

   ReadIndicatorValues();//For initial display in case user has turned of constant re-display
   DisplayUserFeedback();
   
   //Call sq's show trades indi
   //iCustom(NULL, 0, "SQ_showTrades",Magic, 0,0);   
//----
   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
//----
   Comment("");
   if (UseShakeRecovery)
   {
      GlobalVariableDel(GV.Cycle);
   }
   
   RemoveObjects(LabelPrefix);
   ObjectDelete("cbox");
   ObjectDelete("cbox2");
   
   // set the trade context free
   UnlockTradingThread();

//----
   return(0);
}

void ShowStats()   
  {
//----
     //Displays pair-by-pair data in lables on the screen
	  RemoveObjects(LabelPrefix);

     double vertical;
     double horizontal;
     string Label_Name;
     int a,y;
     string tmpStr;
     color col;
     
     //Headings
     vertical = DisplayStartsAtCol;
     horizontal = DisplayStartsAtRow;

     Label_Name = LabelPrefix + "headlabel" + DoubleToStr(a, 0);
     Printtxt(WindowExpertName()+" v"+VERSION,Label_Name,FontSize,"Arial", PairColour,vertical,horizontal);
     a++;

     //New line
     horizontal+= RowSpacing;
     
     vertical = DisplayStartsAtCol;
     Label_Name = LabelPrefix + "headlabel" + DoubleToStr(a, 0);
     Printtxt(DATE,Label_Name,FontSize,"Arial", PairColour,vertical,horizontal);
     a++;
     
     //New line
     horizontal+= RowSpacing;           

     vertical = DisplayStartsAtCol;
     Label_Name = LabelPrefix + "headlabel" + DoubleToStr(a, 0);
     Printtxt("----------------------------------------",Label_Name,FontSize,"Arial", PairColour,vertical,horizontal);
     a++;
     
     //New line
     horizontal+= RowSpacing;

     if(TradeLong && TradeShort) tmpStr="Long/Short";col = PairColour;
     if(TradeLong && !TradeShort) tmpStr="Long Only";col = LongTrendColour;
     if(!TradeLong && TradeShort) tmpStr="Short Only";col = ShortTrendColour;
     if(!TradeLong && !TradeShort) tmpStr="Not Trading!";col = RangingColour;
     
     vertical = DisplayStartsAtCol;                        
     DisplayData(vertical, horizontal, a, "Trading:", tmpStr, col);

     //New line
     horizontal+= RowSpacing; 
     vertical = DisplayStartsAtCol;                        
     DisplayData(vertical, horizontal, a, "Lot Size", DoubleToStr(Lot,2), PairColour);

     //New line
     horizontal+= RowSpacing;           

     vertical = DisplayStartsAtCol;                        
     DisplayData(vertical, horizontal, a, "Magic", MagicNumber, PairColour);

     //New line
     horizontal+= RowSpacing; 
     
     vertical = DisplayStartsAtCol;
     tmpStr="False";
     if(CriminalIsECN) tmpStr="True";                        
     DisplayData(vertical, horizontal, a, "ECN", tmpStr, PairColour);

     //New line
     horizontal+= RowSpacing;

     if(StopLoss>0)
     {
         vertical = DisplayStartsAtCol;                        
         DisplayData(vertical, horizontal, a, "StopLoss", StopLoss, PairColour);

        //New line
        horizontal+= RowSpacing; 
        y+=17;
     }
         
     vertical = DisplayStartsAtCol;                        
     double spread=MarketInfo(Symbol(),MODE_SPREAD);
     col = LongTrendColour;
     if (spread>=MaxSpreadAllowed) col = ShortTrendColour;
     DisplayData(vertical, horizontal, a, "Spread", DoubleToStr(spread,0), col);

     //New line
     horizontal+= RowSpacing; 

     if (UseMa)
     {
         vertical = DisplayStartsAtCol;                        
         DisplayData(vertical, horizontal, a, "MA("+MaPeriod+")", DoubleToStr(MaVal,Digits), PairColour);

         //New line
         horizontal+= RowSpacing; 
         y+=17;
     }
     
     if (UseTrendMA)
     {     
         vertical = DisplayStartsAtCol;                        
         DisplayData(vertical, horizontal, a, "MA("+Ma2Period+")", DoubleToStr(Ma2Val,Digits), PairColour);

         //New line
         horizontal+= RowSpacing;
         y+=17;
     }
               
     vertical = DisplayStartsAtCol;                        
     DisplayData(vertical, horizontal, a, "Synergy", DoubleToStr(HaVal,Digits), PairColour);

     //New line
     horizontal+= RowSpacing; 
          
     col = RangingColour;
     if (trend == up) col = LongTrendColour;
     if (trend == down) col = ShortTrendColour;

     vertical = DisplayStartsAtCol;                        
     DisplayData(vertical, horizontal, a, "Synergy Trend", trend, col);

     //New line
     horizontal+= RowSpacing;           

     col = RangingColour;
     if (prev.trend == up) col = LongTrendColour;
     if (prev.trend == down) col = ShortTrendColour;

     vertical = DisplayStartsAtCol;                        
     DisplayData(vertical, horizontal, a, "Prev Trend", prev.trend, col);

     //New line
     horizontal+= RowSpacing; 
     
     if (BreakEven)
     {
         vertical = DisplayStartsAtCol;                        
         DisplayData(vertical, horizontal, a, "BE", BreakEvenPips+":"+BreakEvenProfit, PairColour);

         //New line
         horizontal+= RowSpacing;
         y+=17; 
     }
     if (JumpingStop)
     {
         vertical = DisplayStartsAtCol;                        
         DisplayData(vertical, horizontal, a, "JS", JumpingStopPips, PairColour);

         //New line
         horizontal+= RowSpacing;
         y+=17; 
     }
     if (TrailingStop)
     {
         vertical = DisplayStartsAtCol;                        
         DisplayData(vertical, horizontal, a, "TS", TrailingStopPips, PairColour);

         //New line
         horizontal+= RowSpacing;
         y+=17; 
     }
     if (UseCandlestickTrailingStop)
     {
         vertical = DisplayStartsAtCol;                        
         DisplayData(vertical, horizontal, a, "CTS", CstTrailCandles+" Candles", PairColour);

         //New line
         horizontal+= RowSpacing; 
         y+=17;
     }
     
     vertical = DisplayStartsAtCol;                        
     DisplayData(vertical, horizontal, a, "Results today", "W: "+WinTrades+"/L: "+LossTrades, PairColour);

     //New line
     horizontal+= RowSpacing;

     col = RangingColour;
     if (OverallProfit>0) col = LongTrendColour;
     if (OverallProfit<0) col = ShortTrendColour;

     vertical = DisplayStartsAtCol;                        
     DisplayData(vertical, horizontal, a, "P/L",DoubleToStr(OverallProfit, 2), col);

     //New line
     horizontal+= RowSpacing;
     
     ObjectSet("cbox3", OBJPROP_YDISTANCE, CommentBoxYDist+y);
     ObjectSet("cbox4", OBJPROP_YDISTANCE, CommentBoxYDist+y); 
//----
   return(0);
  }
//+------------------------------------------------------------------+

void DisplayData(int vert, int horiz, int& a, string text, string text2, color col)
{                       
     string Label_Name = LabelPrefix + DoubleToStr(a, 0);
     Printtxt(text2,Label_Name,FontSize,"Arial", col,vert,horiz);
     a++;

     vert+= ColumnSpacing;
     Label_Name = LabelPrefix + "headlabel" + DoubleToStr(a, 0);
     Printtxt(text,Label_Name,FontSize,"Arial", PairColour,vert,horiz);
     a++;
}
//+------------------------------------------------------------------+
void Printtxt(string text, string str,int size, string font, color vcolor, double vertical, double horizontal) 
{
   //if (ObjectFind(str) != 0)
   if (ObjectFind(str) == -1)
   {
      ObjectCreate(str, OBJ_LABEL, 0, 0, 0);      
   }
   ObjectSetText(str, text, size, font, vcolor);
   ObjectSet(str, OBJPROP_XDISTANCE, 0 + vertical);
   ObjectSet(str, OBJPROP_YDISTANCE, 0 + 14.0 * horizontal);
   ObjectSet(str, OBJPROP_CORNER, 1);
   
}//End void Printtxt(string text, string str,int size, string font, color vcolor = -1, double vertical = -1.0, int horizontal = 0) {
//+------------------------------------------------------------------+

void RemoveObjects(string Pref)
{   
	int i;
	string objname = "";

	for (i = ObjectsTotal(); i >= 0; i--)
	{
		objname = ObjectName(i);
		if (StringFind(objname, Pref, 0) > -1) ObjectDelete(objname);
	}
	return(0);
} // End void RemoveObjects(string Pref)
//+------------------------------------------------------------------+

////////////////////////////////////////////////////////////////////////////////////////////////
//TRADE MANAGEMENT MODULE

void ReportError()
{
   //All purpose sl mod error reporter. Called when a sl mod fails
   
   int err=GetLastError();
   
   if (err>1)   
   {
      Alert(OrderTicket()," stop loss modification failed with error(",err,"): ",ErrorDescription(err));
      Print(OrderTicket()," stop loss modification failed with error(",err,"): ",ErrorDescription(err));      
   }
}//void ReportError()

bool CheckValidSL(double sl)//magft
{

   double NewSL=NormalizeDouble(MathAbs(sl - OrderStopLoss()),Digits);
   double freeze=MarketInfo(Symbol(),MODE_FREEZELEVEL);
   double stoplevel=MarketInfo(Symbol(),MODE_STOPLEVEL);
   double spread=MarketInfo(Symbol(),MODE_SPREAD);
   
   if (OrderType()==OP_BUY) double price=NormalizeDouble(Ask,Digits);
   if (OrderType()==OP_SELL) price=NormalizeDouble(Bid,Digits);
   
   double sldiff=NormalizeDouble(MathAbs(sl-price),Digits);
    
   if(NewSL==0||sldiff==0) return(false);
   
   if (NewSL <= Point)
   {
      //if(IsTesting()) Print(OrderTicket()," Cannot Modify SL ",OrderStopLoss(),", New SL ",sl,", NewSL-OpenPrice ",NewSL," < Point");
      return(false);//George again. What a guy
   }
   
   //find largest broker sl
   double minsl=MathMax(freeze,stoplevel)*Point;
   
   //check if new stop is bigger than broker min
   if (sldiff < minsl) 
   {
      if(IsTesting()) Print(OrderTicket()," Cannot Modify SL ",OrderStopLoss(),", New SL ",sl," Price ",price,", NewSL-Price ",sldiff," <= Broker Min ",minsl);
      return(false);
   }
   
   //if get here good to modify
   return(true);
}

void BreakEvenStopLoss() // Move stop loss to breakeven
{

   double NewStop;
   bool result;
   bool modify=false;
   double sl=OrderStopLoss();
      
   if (OrderType()==OP_BUY)
   {
      if (sl >= OrderOpenPrice() ) return;
      if (Bid >= OrderOpenPrice () + (Point*BreakEvenPips))          
      {
         //Calculate the new stop
         NewStop = NormalizeDouble(OrderOpenPrice()+(BreakEvenProfit*Point), Digits);
         if (!CheckValidSL(NewStop)) return;
         modify = true;   
      }//if (Bid >= OrderOpenPrice () + (Point*BreakEvenPips) && 
   }//if (OrderType()==OP_BUY)               			         
    
   if (OrderType()==OP_SELL)
   {
     if (sl <= OrderOpenPrice() && sl > 0) return;
     if (Ask <= OrderOpenPrice() - (Point*BreakEvenPips)) 
     {
         //Calculate the new stop
         NewStop = NormalizeDouble(OrderOpenPrice()-(BreakEvenProfit*Point), Digits);
         if (!CheckValidSL(NewStop)) return;     
         modify = true;   
     }//if (Ask <= OrderOpenPrice() - (Point*BreakEvenPips) && (OrderStopLoss()>OrderOpenPrice()|| OrderStopLoss()==0))     
   }//if (OrderType()==OP_SELL)

   if (modify)
   {
     //ok, we can trade now
      for (int cc = 0; cc < RetryCount; cc++)
      {
         RefreshRates();  //make sure we have updated info
         result = _OrderModify(OrderTicket(), OrderOpenPrice(), NewStop, OrderTakeProfit(), OrderExpiration(), CLR_NONE);      
         if (!result) ReportError();
      }

   }//if (modify) 
   
} // End BreakevenStopLoss sub

void JumpingStopLoss() 
{
   // Jump sl by pips and at intervals chosen by user .

   //if (OrderProfit() < 0) return;//Nothing to do
   double sl = OrderStopLoss();

   double NewStop;
   bool modify=false;
   bool result;
   
   
    if (OrderType()==OP_BUY)
    {
       //if (sl < OrderOpenPrice() ) return;//Not at breakeven yet
       // Increment sl by sl + JumpingStopPips.
       // This will happen when market price >= (sl + JumpingStopPips)
       //if (Bid>= sl + ((JumpingStopPips*2)*Point) )
       sl = MathMax(sl, OrderOpenPrice());
       if (Bid >=  sl + ((JumpingStopPips * 2) * Point) )//George{
       {
          NewStop = NormalizeDouble(sl + (JumpingStopPips * Point), Digits);
          if (AddBEP) NewStop = NormalizeDouble(NewStop + (BreakEvenProfit*Point), Digits);
          if (NewStop - OrderStopLoss() >= Point) modify = true;//George again. What a guy
          if (!CheckValidSL(NewStop)) return;
          modify = true;
       }// if (Bid>= sl + (JumpingStopPips*Point) && sl>= OrderOpenPrice())     
    }//if (OrderType()==OP_BUY)
       
    if (OrderType()==OP_SELL)
    {
          //if (sl > OrderOpenPrice() ) return;//Not at breakeven yet
          // Decrement sl by sl - JumpingStopPips.
          // This will happen when market price <= (sl - JumpingStopPips)
          //if (Bid<= sl - ((JumpingStopPips*2)*Point)) Original code
          sl = MathMin(sl, OrderOpenPrice());
          if (sl == 0) sl = OrderOpenPrice();
          if (Bid <= sl - ((JumpingStopPips * 2) * Point) )//George
          {
             NewStop = NormalizeDouble(sl - (JumpingStopPips * Point), Digits);
             if (AddBEP) NewStop = NormalizeDouble(NewStop - (BreakEvenProfit*Point), Digits);
             //if (OrderStopLoss() - NewStop >= Point || OrderStopLoss() == 0) modify = true;//George again. What a guy
             if (!CheckValidSL(NewStop)) return;
             modify = true;   
          }// close if (Bid>= sl + (JumpingStopPips*Point) && sl>= OrderOpenPrice())         
   }//if (OrderType()==OP_SELL)

   if (modify)
   { 
     //ok, we can trade now
      for (int cc = 0; cc < RetryCount; cc++)
      {
         RefreshRates();  //make sure we have updated info
         result = _OrderModify(OrderTicket(), OrderOpenPrice(), NewStop, OrderTakeProfit(), OrderExpiration(), CLR_NONE);      
         if (!result) ReportError();
      }

   }//if (modify) 

} //End of JumpingStopLoss sub

void TrailingStopLoss()
{
   
   if (OrderProfit() < 0) return;//Nothing to do
   double sl = OrderStopLoss();
   double NewStop;
   bool modify=false;
   bool result;
   
    if (OrderType()==OP_BUY)
       {
          //if (sl < OrderOpenPrice() ) return;//Not at breakeven yet
          // Increment sl by sl + TrailingStopPips.
          // This will happen when market price >= (sl + JumpingStopPips)
          //if (Bid>= sl + (TrailingStopPips * Point) ) Original code
          sl = MathMax(sl, OrderOpenPrice());
          if (Bid >= sl + (TrailingStopPips * Point) )//George
          {
             NewStop = NormalizeDouble(sl + (TrailingStopPips * Point), Digits);
             //if (NewStop - OrderStopLoss() >= Point) modify = true;//George again. What a guy
             if (!CheckValidSL(NewStop)) return;
             modify = true;
          }//if (Bid >= MathMax(sl,OrderOpenPrice()) + (TrailingStopPips * Point) )//George
       }//if (OrderType()==OP_BUY)
       
   if (OrderType()==OP_SELL)
       {
          //if (sl > OrderOpenPrice() ) return;//Not at breakeven yet
          // Decrement sl by sl - TrailingStopPips.
          // This will happen when market price <= (sl - JumpingStopPips)
          //if (Bid<= sl - (TrailingStopPips * Point) ) Original code
          sl = MathMin(sl, OrderOpenPrice());
          if (sl == 0) sl = OrderOpenPrice();
          if (Bid <= sl  - (TrailingStopPips * Point))//George
          {
             NewStop = NormalizeDouble(sl - (TrailingStopPips * Point), Digits);
             //if (OrderStopLoss() - NewStop >= Point || OrderStopLoss() == 0) modify = true;//George again. What a guy   
             if (!CheckValidSL(NewStop)) return;
             modify = true;
          }//if (Bid <= MathMin(sl, OrderOpenPrice() ) - (TrailingStopPips * Point) )//George
   }//if (OrderType()==OP_SELL)

   if (modify)
   {
     //ok, we can trade now
      for (int cc = 0; cc < RetryCount; cc++)
      {
         RefreshRates();  //make sure we have updated info
         result = _OrderModify(OrderTicket(), OrderOpenPrice(), NewStop, OrderTakeProfit(), OrderExpiration(), CLR_NONE);      
         if (!result) ReportError();
      }

   }//if (modify) 
      
} // End of TrailingStopLoss sub

void CandlestickTrailingStop()
{
   
   //Trails the stop at the hi/lo of the previous candle shifted by the user choice.
   //Only tries to do this once per bar, so an invalid stop error will only be generated once. I could code for
   //a too-close sl, but cannot be arsed. Coders, sort this out for yourselves.
   
   if (OldCstBars == iBars(Symbol(),RenkoTF)) return;
   OldCstBars = iBars(Symbol(),RenkoTF);

   if (OrderProfit() < 0) return;//Nothing to do
   double sl=OrderStopLoss();
   double NewStop;
   bool modify=false;
   bool result;
   //double MinStop=MarketInfo(Symbol(),MODE_FREEZELEVEL);   

   RefreshRates();
   
   if (OrderType() == OP_BUY)
   {
      //if (iLow(NULL, CstTimeFrame, CstTrailCandles) > sl)
      if(HaLow > sl)
      {
         //NewStop = NormalizeDouble(Low[1], Digits);
         NewStop = NormalizeDouble(HaLow, Digits);
         //if (!CheckValidSL(NewStop)) return;
         if (Ask > NewStop && sl != NewStop) modify = true;   
      }//if (iLow(NULL, CstTimeFrame, CstTrailCandles) > sl)
   }//if (OrderType == OP_BUY)
   
   if (OrderType() == OP_SELL)
   {
      //if (iHigh(NULL, CstTimeFrame, CstTrailCandles) < sl)
      if(HaHigh < sl)
      {
         //NewStop = NormalizeDouble(High[1], Digits);
         NewStop = NormalizeDouble(HaHigh, Digits);
         //if (!CheckValidSL(NewStop)) return;
         if (Bid < NewStop && sl != NewStop) modify = true;  
      }//if (iHigh(NULL, CstTimeFrame, CstTrailCandles) < sl)
   }//if (OrderType() == OP_SELL)
   
   if (modify)
   {
      //ok, we can trade now
      for (int cc = 0; cc < RetryCount; cc++)
      {         
         RefreshRates();  //make sure we have updated info
         result = _OrderModify(OrderTicket(), OrderOpenPrice(), NewStop, OrderTakeProfit(), OrderExpiration(), CLR_NONE);      
         if (!result) 
         {
            int err=GetLastError();
            if (err>1 && err!=130) ReportError();
            else break;
         }//if (result) break;
      }
   }//if (modify)

}//End void CandlestickTrailingStop()

void TradeManagementModule()
{

   // Call the working subroutines one by one. 

   //Candlestick trailing stop
   if (UseCandlestickTrailingStop) CandlestickTrailingStop();

   // Breakeven
   if(BreakEven) BreakEvenStopLoss();

   // JumpingStop
   if(JumpingStop) JumpingStopLoss();

   //TrailingStop
   if(TrailingStop) TrailingStopLoss();

}//void TradeManagementModule()
//END TRADE MANAGEMENT MODULE
////////////////////////////////////////////////////////////////////////////////////////////////

int RandomTime()
{
   //randomise sleep period
   MathSrand(iTime(Symbol(),PERIOD_M1,0));
   
   int ret=MathRand()*1000;
   
   if (ret<100) ret=100;
   
   return(ret);
}

bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)
{
   //pah (Paul) contributed the code to get around the trade context busy error. Many thanks, Paul.
   
   int slippage = 10;
   if (Digits == 3 || Digits == 5) slippage = 100;
   
   color col = Red;
   if (type == OP_BUY || type == OP_BUYSTOP) col = Green;
   
   int expiry = 0;
   //if (SendPendingTrades) expiry = TimeCurrent() + (PendingExpiryMinutes * 60);
   
   //RetryCount is declared as 10 in the Trading variables section at the top of this file
   for (int cc = 0; cc < RetryCount; cc++)
   {
      for (int d = 0; (d < RetryCount) && IsTradeContextBusy(); d++) Sleep(RandomTime());
      
      RefreshRates();
      if (type == OP_BUY) price = NormalizeDouble(Ask, Digits);
      if (type == OP_SELL) price = NormalizeDouble(Bid, Digits);
      
      if (!CriminalIsECN) int ticket = _OrderSend(Symbol(),type, lotsize, price, slippage, stop, take, comment, MagicNumber, expiry, col);

      //Is a 2 stage criminal
      if (CriminalIsECN)
      {
         ticket = _OrderSend(Symbol(),type, lotsize, price, slippage, 0, 0, comment, MagicNumber, expiry, col);
         if (ticket > -1)
         {
	           ModifyOrder(ticket, stop, take);
         }//if (ticket > 0)}
      }//if (CriminalIsECN)
      
      if (ticket > -1) break;//Exit the trade send loop
      if (cc == RetryCount - 1) return(false);
   
      //Error trapping for both
      if (ticket < 0)
      {
         string stype;
         if (type == OP_BUY) stype = "OP_BUY";
         if (type == OP_SELL) stype = "OP_SELL";
         if (type == OP_BUYLIMIT) stype = "OP_BUYLIMIT";
         if (type == OP_SELLLIMIT) stype = "OP_SELLLIMIT";
         if (type == OP_BUYSTOP) stype = "OP_BUYSTOP";
         if (type == OP_SELLSTOP) stype = "OP_SELLSTOP";
         int err=GetLastError();
         Alert(Symbol(),",",Period(), " ", WindowExpertName(), " ", stype," order send failed with error(",err,"): ",ErrorDescription(err));
         Print(Symbol(),",",Period(), " ", WindowExpertName(), " ", stype," order send failed with error(",err,"): ",ErrorDescription(err));
         return(false);
      }//if (ticket < 0)  
   }//for (int cc = 0; cc < RetryCount; cc++);
   
   TicketNo = ticket;
   //Make sure the trade has appeared in the platform's history to avoid duplicate trades.
   //My mod of Matt's code attempts to overcome the bastard crim's attempts to overcome Matt's code.
   bool TradeReturnedFromCriminal = false;
   while (!TradeReturnedFromCriminal)
   {
      TradeReturnedFromCriminal = O_R_CheckForHistory(ticket);
      if (!TradeReturnedFromCriminal)
      {
         Alert(Symbol(),",",Period(), " sent trade not in your trade history yet. Turn of this ea NOW.");
      }//if (!TradeReturnedFromCriminal)
   }//while (!TradeReturnedFromCriminal)
    
   //Got this far, so trade send succeeded
   return(true);
   
}//End bool SendSingleTrade(int type, string comment, double lotsize, double price, double stop, double take)

void ModifyOrder(int ticket, double stop, double take)
{
   //Modifies an order already sent if the crim is ECN.

   if (stop == 0 && take == 0) return; //nothing to do

   if (!OrderSelect(ticket, SELECT_BY_TICKET) ) return;//Trade does not exist, so no mod needed
   
   //RetryCount is declared as 10 in the Trading variables section at the top of this file   
   for (int cc = 0; cc < RetryCount; cc++)
   {
      for (int d = 0; (d < RetryCount) && IsTradeContextBusy(); d++) Sleep(RandomTime());
        if (take > 0 && stop > 0)
        {
           while(IsTradeContextBusy()) Sleep(RandomTime());
           if (_OrderModify(ticket, OrderOpenPrice(), stop, take, OrderExpiration(), CLR_NONE)) return;           
        }//if (take > 0 && stop > 0)
   
        if (take != 0 && stop == 0)
        {
           while(IsTradeContextBusy()) Sleep(RandomTime());
           if (_OrderModify(ticket, OrderOpenPrice(), OrderStopLoss(), take, OrderExpiration(), CLR_NONE)) return;
        }//if (take == 0 && stop != 0)

        if (take == 0 && stop != 0)
        {
           while(IsTradeContextBusy()) Sleep(RandomTime());
           if (_OrderModify(ticket, OrderOpenPrice(), stop, OrderTakeProfit(), OrderExpiration(), CLR_NONE)) return;
        }//if (take == 0 && stop != 0)
   }//for (int cc = 0; cc < RetryCount; cc++)
   
   //Got this far, so the order modify failed
   int err=GetLastError();
   Print(Symbol(),",",Period(), " SL/TP  order modify failed with error(",err,"): ",ErrorDescription(err));               
   Alert(Symbol(),",",Period(), " SL/TP  order modify failed with error(",err,"): ",ErrorDescription(err));               
  
}//void ModifyOrder(int ticket, double tp, double sl)

//=============================================================================
//                           O_R_CheckForHistory()
//
//  This function is to work around a very annoying and dangerous bug in MT4:
//      immediately after you send a trade, the trade may NOT show up in the
//      order history, even though it exists according to ticket number.
//      As a result, EA's which count history to check for trade entries
//      may give many multiple entries, possibly blowing your account!
//
//  This function will take a ticket number and loop until
//  it is seen in the history.
//
//  RETURN VALUE:
//     TRUE if successful, FALSE otherwise
//
//
//  FEATURES:
//     * Re-trying under some error conditions, sleeping a random
//       time defined by an exponential probability distribution.
//
//     * Displays various error messages on the log for debugging.
//
//  ORIGINAL AUTHOR AND DATE:
//     Matt Kennel, 2010
//
//=============================================================================
bool O_R_CheckForHistory(int ticket)
{
   //My thanks to Matt for this code. He also has the undying gratitude of all users of my trading robots
   
   int lastTicket = OrderTicket();

   int cnt = 0;
   int err = GetLastError(); // so we clear the global variable.
   err = 0;
   bool exit_loop = false;
   bool success=false;

   while (!exit_loop) {
      /* loop through open trades */
      int total=OrdersTotal();
      for(int c = 0; c < total; c++) {
         if(OrderSelect(c,SELECT_BY_POS,MODE_TRADES) == true) {
            if (OrderTicket() == ticket) {
               success = true;
               exit_loop = true;
            }
         }
      }
      if (cnt > 3) {
         /* look through history too, as order may have opened and closed immediately */
         total=OrdersHistoryTotal();
         for(c = 0; c < total; c++) {
            if(OrderSelect(c,SELECT_BY_POS,MODE_HISTORY) == true) {
               if (OrderTicket() == ticket) {
                  success = true;
                  exit_loop = true;
               }
            }
         }
      }

      cnt = cnt+1;
      if (cnt > O_R_Setting_max_retries) {
         exit_loop = true;
      }
      if (!(success || exit_loop)) {
         Print("Did not find #"+ticket+" in history, sleeping, then doing retry #"+cnt);
         O_R_Sleep(O_R_Setting_sleep_time, O_R_Setting_sleep_max);
      }
   }
   // Select back the prior ticket num in case caller was using it.
   if (lastTicket >= 0) {
      OrderSelect(lastTicket, SELECT_BY_TICKET, MODE_TRADES);
   }
   if (!success) {
      Print("Never found #"+ticket+" in history! crap!");
   }
   return(success);
}//End bool O_R_CheckForHistory(int ticket)

//=============================================================================
//                              O_R_Sleep()
//
//  This sleeps a random amount of time defined by an exponential
//  probability distribution. The mean time, in Seconds is given
//  in 'mean_time'.
//  This returns immediately if we are backtesting
//  and does not sleep.
//
//=============================================================================
void O_R_Sleep(double mean_time, double max_time)
{
   if (IsTesting()) {
      return;   // return immediately if backtesting.
   }

   double p = (MathRand()+1) / 32768.0;
   double t = -MathLog(p)*mean_time;
   t = MathMin(t,max_time);
   int ms = t*1000;
   if (ms < 10) {
      ms=10;
   }
   Sleep(ms);
}//End void O_R_Sleep(double mean_time, double max_time)


///////////////////////////////////////////////////////////////////////////////////////////////////////


bool IsTradingAllowed(string& Msg)
{
   //Returns false if any of the filters should cancel trading, else returns true to allow trading
      
   //Maximum spread
   if (MarketInfo(Symbol(), MODE_SPREAD) > MaxSpreadAllowed)
   {
      Msg="Spread above Max Spread!";
      return(false);
   }
   
   //check MT4 will let us trade
   if(IsStopped()||!IsConnected()||!IsTradeAllowed())
   {
      Msg="Check EA Settings Tab!";
      return(false);
   }

   //Trading times
   bool TradeTimeOk = CheckTradingTimes();
   if (!TradeTimeOk)
   {
      Msg="Outside Trading Hours!";
      return(false);
   }//if (hour < start_hourm)
      
   //Margin check
   if (UseMarginCheck && AccountMargin() > 0)
   {
      double ml = NormalizeDouble(AccountEquity() / AccountMargin() * 100, 2);
      if (ml < MinMarginPercent)
      {
         MarginMessage = StringConcatenate("There is insufficient margin percent to allow trading. ", DoubleToStr(ml, 2), "%");
         return(false);
      }  
   }   
   //if get here good to go
   return(true);

}//End bool IsTradingAllowed()

double CalculateLotSize(double price1, double price2)
{
   //Calculate the lot size by risk. Code kindly supplied by jmw1970. Nice one jmw.
   
   if (price1 == 0 || price2 == 0) return(Lot);//Just in case
   
   double FreeMargin = AccountFreeMargin();
   double TickValue = MarketInfo(Symbol(),MODE_TICKVALUE) ;
   double LotStep = MarketInfo(Symbol(),MODE_LOTSTEP);


   double SLPts = MathAbs(price1 - price2);
   SLPts/= Point;
   
   double Exposure = SLPts * TickValue; // Exposure based on 1 full lot

   double AllowedExposure = (FreeMargin * RiskPercent) / 100;
   
   int TotalSteps = ((AllowedExposure / Exposure) / LotStep);
   double LotSize = TotalSteps * LotStep;

   double MinLots = MarketInfo(Symbol(), MODE_MINLOT);
   double MaxLots = MarketInfo(Symbol(), MODE_MAXLOT);
   
   if (LotSize < MinLots) LotSize = MinLots;
   if (LotSize > MaxLots) LotSize = MaxLots;
   return(LotSize);

}//double CalculateLotSize(double price1, double price1)

double CalculateLotSizeMart()
{
   //Calculate Martingale lot size
   
   if (!UseMartingale) return(Lot);   
   
   //Find most recent trade
   if (OrdersHistoryTotal() == 0) return(Lot);
   double SendLots = Lot;
   
   for (int cc = OrdersHistoryTotal() - 1; cc >= 0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS, MODE_HISTORY) ) continue;
      if (OrderSymbol() != Symbol() ) continue;
      if (OrderMagicNumber() != MagicNumber) continue;
      if (OrderProfit() < 0)
      {
         double LotStep = MarketInfo(Symbol(),MODE_LOTSTEP);
         double digit = 0;
         if (LotStep == 0.1) digit = 1;
         if (LotStep == 0.01) digit = 2;
         SendLots = NormalizeDouble(OrderLots() * MartingaleLotMultiplier, digit);         
      }//if (OrderProfit() < 0)
      break;
   
   }//for (int cc = OrdersHistoryTotal() - 1; cc >= 0; cc--)
   
   //Check maximum lots allowed filter in the Martingale section
   if (SendLots > MaxLotsAllowed) SendLots = Lot;
   
   return(SendLots);

}//End double CalculateLotSize()

double CalculateLotSizeShake()
{
   if (!UseShakeRecovery) return(Lot);   
      
   if (OrdersHistoryTotal() == 0) return(Lot);
   double SendLots = Lot;
   
   //varibles to track through the history to see where we are in a sequence
   double MaxOrderLots=0;
   double runningPL=0;
   double LastOrderProfit=0;
   
   //scan through history, "replaying" sequences
   //for (int cc=0;cc < OrdersHistoryTotal();cc++)
   int LastCompleteCycle=GlobalVariableGet(GV.Cycle);
   for (int cc=LastCompleteCycle;cc < OrdersHistoryTotal();cc++)
   {
      if (!OrderSelect(cc, SELECT_BY_POS, MODE_HISTORY) ) continue;
      if (OrderSymbol() != Symbol() ) continue;
      if (OrderMagicNumber() != MagicNumber) continue;
      
      runningPL = runningPL + OrderProfit();
      LastOrderProfit = OrderProfit();
      MaxOrderLots = MathMax(OrderLots(),MaxOrderLots);
      
      //if after this trade we are in a profit (or B/E), reset everything
      if (runningPL >= 0) {
         MaxOrderLots=0;
         runningPL=0;
         LastOrderProfit=0;
         LastCompleteCycle=cc-1;
         GlobalVariableSet(GV.Cycle,LastCompleteCycle);
      }
   }//for (int cc = OrdersHistoryTotal() - 1; cc >= 0; cc--)
   
   //last sequence ended in profit, so restart
   if (runningPL >= 0) SendLots = Lot;        
   
   //current sequence is at a loss, and last trade was a loss, 
   //so send initial lot size
   if (runningPL < 0 && LastOrderProfit < 0)  
      SendLots = Lot;

   //current sequence is at a loss, and last trade was a win, 
   //so increment lot size over max lot so far
   if (runningPL < 0 && LastOrderProfit > 0)  
      SendLots = Lot + MaxOrderLots;
   
   //Check maximum lots allowed filter in the ShakeRecovery section
   if (SendLots > MaxLots.Allowed) 
      SendLots = Lot;
      
   return(SendLots);

}//End double CalculateLotSizeShake()

int CheckLastTradeType()
{
   //Find most recent trade and return type
   if (OrdersHistoryTotal() == 0) return(-1);
   
   for (int cc = OrdersHistoryTotal() - 1; cc >= 0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS, MODE_HISTORY) ) continue;
      if (OrderSymbol() != Symbol() ) continue;
      if (OrderMagicNumber() != MagicNumber) continue;
      
      return (OrderType());
   
   }//for (int cc = OrdersHistoryTotal() - 1; cc >= 0; cc--)
   
   return(-1);
}

double CalculateStopLoss(int type)
{
   //Returns the stop loss for use in LookForTradingOpps and InsertMissingStopLoss
   double stop, price;

   RefreshRates();
   
   if (type == OP_BUY)
   {
      price = Ask;
      if (StopLoss > 0) 
      {
         stop = NormalizeDouble(price - (StopLoss * Point), Digits);
      }//if (StopLoss > 0) 

      //synergy_apb sl on previous change of color
      if ((UseLastColorChangeSL || UsePreviousCandleSL) && StopLoss==0 && HaSL > 0) 
      {
         stop = NormalizeDouble(HaSL, Digits);
      }//if (StopLoss > 0)
   }//if (type == OP_BUY)
   
   if (type == OP_SELL)
   {
      price = Bid;
      if (StopLoss > 0) 
      {
         stop = NormalizeDouble(price + (StopLoss * Point), Digits);
      }//if (StopLoss > 0) 
      
      //synergy_apb sl on previous change of color
      if ((UseLastColorChangeSL || UsePreviousCandleSL) && StopLoss==0 && HaSL > 0) 
      {
         stop = NormalizeDouble(HaSL, Digits);
      }//if (StopLoss > 0)
   }//if (type == OP_SELL)
   
   return(stop);
   
}//End double CalculateStopLoss(int type)

double CalculateTakeProfit(int type)
{
   //Returns the stop loss for use in LookForTradingOpps and InsertMissingStopLoss
   double take, price;

   RefreshRates();
   
   if (type == OP_BUY)
   {
      price = Ask;
      if (TakeProfit > 0) 
      {
         take = NormalizeDouble(price + (TakeProfit * Point), Digits);
      }//if (TakeProfit > 0) 
   }//if (type == OP_BUY)
   
   if (type == OP_SELL)
   {
      price = Bid;
      if (TakeProfit > 0) 
      {
         take = NormalizeDouble(price - (TakeProfit * Point), Digits);
      }//if (TakeProfit > 0) 
      
   }//if (type == OP_SELL)
   
   return(take);
   
}//End double CalculateTakeProfit(int type)

void LookForTradingOpportunities()
{
   RefreshRates();
   double take, stop, price;
   int type;
   bool SendTrade;
   string Msg;

   //Initialise lotsize
   double SendLots = Lot;
   
   //Calculate lotsize to cater for Martingale
   if (UseMartingale) SendLots = CalculateLotSizeMart();
   //Calcualte lotsize to cater for Shake Recovery
   if (UseShakeRecovery) SendLots = CalculateLotSizeShake();

   //Check filters
   if (!IsTradingAllowed(Msg) )
   {
      Print ("Trading NOT Allowed! ",Msg); return;
   }
   
   //Long 
   if (trend==up)
   {
      if (!TradeLong) return;
      if (UseMa && HaVal<(MaVal+MaBufferPips*Point)) return;
      if (UseTrendMA && HaVal<Ma2Val) return;
      if (UseOpenTradeOnOppSignal && CheckLastTradeType()== OP_BUY) return;
       
      price = Ask;//Change this to whatever the price needs to be
      
      stop = CalculateStopLoss(OP_BUY);
      
      take = CalculateTakeProfit(OP_BUY);
                 
      //Lot size calculated by risk
      if ((!UseMartingale && !UseShakeRecovery) && RiskPercent > 0) SendLots = CalculateLotSize(price, NormalizeDouble(stop, Digits) );

      type = OP_BUY;
      SendTrade = true;
   }//if (Bid > 0)

   //Short
   if (trend==down)
   {
      if (!TradeShort) return;
      if (UseMa && HaVal>(MaVal-MaBufferPips*Point)) return;
      if (UseTrendMA && HaVal>Ma2Val) return;
      if (UseOpenTradeOnOppSignal && CheckLastTradeType()== OP_SELL) return;

      price = Bid;//Change this to whatever the price needs to be
      
      stop = CalculateStopLoss(OP_SELL);    
      
      take = CalculateTakeProfit(OP_SELL);
      
      //Lot size calculated by risk
      if ((!UseMartingale && !UseShakeRecovery) && RiskPercent > 0) SendLots = CalculateLotSize(NormalizeDouble(stop, Digits), price);
      
      type = OP_SELL;
      SendTrade = true;      
   }//if (Ask < 0)

   if (SendTrade)
   {
      bool result = SendSingleTrade(type, TradeComment, SendLots, price, stop, take);
   }//if (SendTrade)
   
   //Actions when trade send succeeds
   if (SendTrade && result)
   {

   }//if (result)
   
   //Actions when trade send fails
   if (SendTrade && !result)
   {
   
   }//if (!result)
}//void LookForTradingOpportunities()

bool CloseTrade(int ticket)
{   
   while(IsTradeContextBusy()) Sleep(100);
   bool result = OrderClose(ticket, OrderLots(), OrderClosePrice(), 1000, CLR_NONE);

   //Actions when trade send succeeds
   if (result)
   {
      return(true);
   }//if (result)
   
   //Actions when trade send fails
   if (!result)
   {
      return(false);
   }//if (!result)
   

}//End bool CloseTrade(ticket)

////////////////////////////////////////////////////////////////////////////////////////////////
//Indicator module

double GetMa(int tf, int period, int mashift, int method, int ap, int shift)
{
   return(iMA(NULL, tf, period, mashift, method, ap, shift) );
}//End double GetMa(int tf, int period, int mashift, int method, int ap, int shift)

int GetHa()
{
   string current.trend;
   double Ha.Close,Ha.Open;
   //---- indicator buffers
   double HA_0_Buffer[];
   double HA_1_Buffer[];
   double HA_Open_Buffer[];
   double HA_Close_Buffer[];

   //store current value for MA check
   //HaVal0=iCustom(NULL, SynergyTF, "Synergy_APB", 3, 0);
   
   //Use built in synergy_apb code for speed increase
   if(!Get_Synergy_APB_Series(0, Symbol(), RenkoTF, true, HA_0_Buffer,
                              HA_1_Buffer,HA_Open_Buffer,HA_Close_Buffer))
   return(0);

   for (int i=HaStart;i<20;i++)
   {     
      /*
      //grab indicator values - will need to add to EA for speed
      double ha0=iCustom(NULL, SynergyTF, "Synergy_APB", 0, i);
      double ha1=iCustom(NULL, SynergyTF, "Synergy_APB", 1, i);
      HaOpen=iCustom(NULL, SynergyTF, "Synergy_APB", 2, i); 
      HaClose=iCustom(NULL, SynergyTF, "Synergy_APB", 3, i);
      */
      double ha0=HA_0_Buffer[i];
      double ha1=HA_1_Buffer[i];
      HaOpen=HA_Open_Buffer[i];
      HaClose=HA_Close_Buffer[i];
      
      //store current value for TP and candlestick TS calc
      if (i==1||i==CstTrailCandles)
      {
         HaVal=HaClose;
         HaLow=MathMin(ha0,ha1);
         HaHigh=MathMax(ha0,ha1);
      }
       
      //check direction
      if (HaOpen<HaClose) 
      {
         current.trend=up; 
         if (i==HaStart)
         {
            trend=up;
            if (UsePreviousCandleSL) HaSL=MathMin(ha0,ha1)-PreviousCandleSLOffset*Point;
         }
         if (i==HaStart+1) prev.trend=up;
         if(i>HaStart)
         {
            //if color change store value for SL
            if (!UsePreviousCandleSL && current.trend!=trend) HaSL=MathMin(ha0,ha1);
            break;
         }
      }
      else 
      {
         current.trend=down; 
         if (i==HaStart)
         {
            trend=down;
            if (UsePreviousCandleSL) HaSL=MathMax(ha0,ha1)+PreviousCandleSLOffset*Point;
         }
         if (i==HaStart+1) prev.trend=down;
         if(i>HaStart)
         {
            //if color change store value for SL
            if (!UsePreviousCandleSL && current.trend!=trend) HaSL=MathMax(ha0,ha1);
            break;
         }
      }   
   }      
   
   return(0);

}//End double GetHA(int tf, int shift)

void CalculateDailyResult()
{
   //Calculate the no of winners and losers from today's trading. These are held in the history tab.

   LossTrades = 0;
   WinTrades = 0;
   OverallProfit = 0;
   
   
   for (int cc = 0; cc <= OrdersHistoryTotal(); cc++)
   {
      if (!OrderSelect(cc, SELECT_BY_POS, MODE_HISTORY) ) continue;
      if (OrderSymbol() != Symbol() ) continue;
      if (OrderMagicNumber() != MagicNumber) continue;
      
      OverallProfit+= (OrderProfit() + OrderSwap() + OrderCommission() );
      if (OrderProfit() > 0) WinTrades++;
      if (OrderProfit() < 0) LossTrades++;
   }//for (int cc = 0; cc <= tot -1; cc++)
}//End void CalculateDailyResult()

void ReadIndicatorValues()
{

   MaVal = GetMa(MaTF, MaPeriod, MaShift, MaMethod, MaAppliedPrice, HaStart);
   Ma2Val = GetMa(Ma2TF, Ma2Period, Ma2Shift, Ma2Method, Ma2AppliedPrice, HaStart);

   GetHa();

}//void ReadIndicatorValues()

//+--------------------------------------------------------------------+
//|                                         Get_Synergy_APB_Series.mqh |
//|                                           Copyright  2012, magft. |
//|                    Original Indicator Copyright  2009, CompassFX. |
//| Indicator converted for use in EA instead of iCustom using article |
//|        http://articles.mql4.com/501 & http://articles.mql4.com/502 |
//|                             http://www.stevehopwoodforex.com/magft |
//+--------------------------------------------------------------------+
bool Get_Synergy_APB_Series(int Number, string symbol, int timeframe, 
                           bool NullBarRecount, double& HA_0_Buffer[], 
                           double& HA_1_Buffer[], double& HA_Open_Buffer[],
                           double& HA_Close_Buffer[])    
   {
//---- getting the number of all bars of a chart
   int IBARS = iBars(symbol, timeframe);  
//---- Checking whether the bars number is enough for further calculation
   int MinBars=10;
   if(IBARS < MinBars) return(false);
//---- EMULATION OF INDICATOR BUFFERS
   if(ArraySize(HA_0_Buffer) < IBARS)
   {
       //---- Set the direct indexing direction in the array 
       ArraySetAsSeries(HA_0_Buffer, false);
       ArraySetAsSeries(HA_1_Buffer, false);
       ArraySetAsSeries(HA_Open_Buffer, false);
       ArraySetAsSeries(HA_Close_Buffer, false);
       //---- Change the size of the emulated indicator buffers 
       ArrayResize(HA_0_Buffer, IBARS); 
       ArrayResize(HA_1_Buffer, IBARS); 
       ArrayResize(HA_Open_Buffer, IBARS);
       ArrayResize(HA_Close_Buffer, IBARS);
       //---- Set the reverse indexing direction in the array 
       ArraySetAsSeries(HA_0_Buffer, true);
       ArraySetAsSeries(HA_1_Buffer, true);
       ArraySetAsSeries(HA_Open_Buffer, true);  
       ArraySetAsSeries(HA_Close_Buffer, true);
   }
//----+  inserting static variables of memory
   static int IndCounted[]; 
//----+ changing the size of static variables
   if(ArraySize(IndCounted) < Number + 1)
     {
       ArrayResize(IndCounted, Number + 1); 
     }
 //----+ Introducing an integer variable
   int LastCountBar;
//----+ Checking whether the recalculation of the zero bar is allowed
   if(!NullBarRecount)
       LastCountBar = 1;
//----+ Introducing floating point variables 
   double open, top, btm, close;
   double _iOpen,_iClose,_iHigh,_iLow;
//----+ Introducing integer variables and getting already calculated bars
   int counted_bars = IndCounted[Number];
//----+ Remembering the amount of all chart bars
   IndCounted[Number] = IBARS - 1;
//----+ THE FIRST CYCLE OF INDICATOR CALCULATION    
   for (int limit = IBARS - counted_bars - 1; limit >= LastCountBar; limit--)
   {
      _iOpen=iOpen(symbol,timeframe,limit);
      _iClose=iClose(symbol,timeframe,limit);
      _iHigh=iHigh(symbol,timeframe,limit);
      _iLow=iLow(symbol,timeframe,limit);
      
      close = NormalizeDouble((_iOpen + _iHigh + _iLow + _iClose) / 4.0, Digits);
      close = (close + _iClose) / 2.0;
      open = (HA_Open_Buffer[limit + 1] + HA_Close_Buffer[limit + 1]) / 2.0;
      top = MathMax(_iHigh, MathMax(open, close));
      btm = MathMin(_iLow, MathMin(open, close));
      if (open < close) {
         HA_0_Buffer[limit] = btm;
         HA_1_Buffer[limit] = top;
      } else {
         HA_0_Buffer[limit] = top;
         HA_1_Buffer[limit] = btm;
      }
      HA_Open_Buffer[limit] = open;
      HA_Close_Buffer[limit] = close;
   } 
//----+  
   return(true);
  }
//+------------------------------------------------------------------+

//End Indicator module
////////////////////////////////////////////////////////////////////////////////////////////////

bool LookForTradeClosure(int ticket)
{
   //Close the trade if the close conditions are met.
   //Called from within CountOpenTrades(). Returns true if a close is needed and succeeds, so that COT can increment cc,
   //else returns false
   
   if (!OrderSelect(ticket, SELECT_BY_TICKET) ) return(true);
   if (OrderSelect(ticket, SELECT_BY_TICKET) && OrderCloseTime() > 0) return(true);
   
   bool CloseThisTrade;
   
   //change of Ha trend 
   if (UseCloseOnColorChange && OldBars!=iBars(Symbol(),RenkoTF) && trend != prev.trend) CloseThisTrade = true;
      
   if (OrderType() == OP_BUY)
   {
      //if trade open and going wrong way and crosses MA by MaBufferPips close
      if (UseCloseOnMACross && HaVal0<(MaVal-MaBufferPips*Point)) CloseThisTrade = true;

   }//if (OrderType() == OP_BUY)
   
   if (OrderType() == OP_SELL)
   {
      //if trade open and going wrong way and crosses MA by MaBufferPips close
      if (UseCloseOnMACross && HaVal0>(MaVal+MaBufferPips*Point)) CloseThisTrade = true;

   }//if (OrderType() == OP_SELL)
   
   if (CloseThisTrade)
   {
      bool result = CloseTrade(TicketNo);
      //Actions when trade close succeeds
      if (result)
      {
         TicketNo = -1;//TicketNo is the most recently trade opened, so this might need editing in a multi-trade EA
         OpenTrades--;//Rather than OpenTrades = 0 to cater for multi-trade EA's
         return(true);//Makes CountOpenTrades increment cc to avoid missing out ccounting a trade
      }//if (result)
   
      //Actions when trade close fails
      if (!result)
      {
         return(false);//Do not increment cc
      }//if (!result)
   }//if (CloseThisTrade)
   
   //Got this far, so no trade closure
   return(false);//Do not increment cc
   
}//End bool LookForTradeClosure()

void CloseAllTrades()
{
   ForceTradeClosure= false;
   
   if (OrdersTotal() == 0) return;
   
   for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      if (OrderMagicNumber() != MagicNumber) continue;
      if (OrderSymbol() != Symbol() ) continue;
      while(IsTradeContextBusy()) Sleep(100);
      if (OrderType() == OP_BUY || OrderType() == OP_SELL) bool result = OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), 1000, CLR_NONE);
      if (result) cc++;
      if (!result) ForceTradeClosure= true;
      
   }//for (int cc = OrdersTotal() - 1; cc >= 0; cc--)

   //If full closure succeeded, then allow new trading
   if (!ForceTradeClosure) 
   {
      OpenTrades = 0;
      BuyOpen = false;
      SellOpen = false;
   }//if (!ForceTradeClosure) 

}//End void CloseAllTrades()


bool CheckTradingTimes()
{
   datetime AsiaBeg, AsiaEnd, EuropeBeg, EuropeEnd, USBeg, USEnd;

   //Skip if trading 24hrs
   if (Trade24hr) return(True);
   
   //datetime Now = TimeLocal();    //use local time
   datetime Now = iTime(Symbol(),PERIOD_M1,0);  //use criminal time

   //we need to cast our conversions into the current date
   AsiaBeg = StrToTime(TimeToStr(Now,TIME_DATE)+" "+ Start_TimeA);
   AsiaEnd = StrToTime(TimeToStr(Now,TIME_DATE)+" "+ End_TimeA);
   EuropeBeg = StrToTime(TimeToStr(Now,TIME_DATE)+" "+ Start_TimeE);
   EuropeEnd = StrToTime(TimeToStr(Now,TIME_DATE)+" "+ End_TimeE);
   USBeg = StrToTime(TimeToStr(Now,TIME_DATE)+" "+ Start_TimeU);
   USEnd = StrToTime(TimeToStr(Now,TIME_DATE)+" "+ End_TimeU);


   bool Asia = false;

   //Check normal case for morning , 7:00-13:00
   if (AsiaBeg < AsiaEnd && (Now >= AsiaBeg && Now < AsiaEnd))
      Asia = true;

   //Check to see if AsiaBeg to AsiaEnd spans 00:00, e.g. 22:00 - 04:00
   if (AsiaEnd < AsiaBeg && (Now >= AsiaBeg || Now < AsiaEnd))
      Asia = true;


   bool Europe = false;
   //Check normal case for Europe , 17:00 - 22:00
   if (EuropeBeg < EuropeEnd && (Now >= EuropeBeg && Now < EuropeEnd))
      Europe = true;

   //Check to see if EuropeBeg-EuropeEnd spans 00:00, 22:00 - 04:00
   if (EuropeEnd < EuropeBeg && (Now >= EuropeBeg || Now < EuropeEnd))
      Europe = true;
   
   bool US = false;
   //Check normal case for US , 17:00 - 22:00
   if (USBeg < USEnd && (Now >= USBeg && Now < USEnd))
      US = true;

   //Check to see if USBeg-USEnd spans 00:00, 22:00 - 04:00
   if (USEnd < USBeg && (Now >= USBeg || Now < USEnd))
      US = true;
   

   return(Asia || Europe || US);
   
}//bool CheckTradingTimes()

void CountOpenTrades()
{
   //Not all these will be needed. Which ones are depends on the individual EA.
   OpenTrades = 0;
   TicketNo = -1;
   BuyOpen = false;
   SellOpen = false;
   PendingBuyOpen = false;
   PendingSellOpen = false;
   int type;//Saves the OrderType() for consulatation later in the function
   
   upl = 0;//Unrealised profit and loss for hedging/recovery basket closure decisions

   //if (OrdersTotal() == 0) return;
   
   //Iterating backwards through the orders list caters more easily for closed trades than iterating forwards
   for (int cc = OrdersTotal() - 1; cc >= 0; cc--)
   {
      bool TradeWasClosed = false;//See 'check for possible trade closure'

      //Ensure the trade is still open
      if (!OrderSelect(cc, SELECT_BY_POS) ) continue;
      //Ensure the EA 'owns' this trade
      if (OrderSymbol() != Symbol() ) continue;
      if (OrderMagicNumber() != MagicNumber) continue;
      
      //All conditions passed, so carry on
      type = OrderType();//Store the order type
      
      OpenTrades++;
      //Store the latest trade sent. Most of my EA's only need this final ticket number as either they are single trade
      //bots or the last trade in the sequence is the important one. Adapt this code for your own use.
      if (TicketNo  == -1) TicketNo = OrderTicket();
      
      //upl might not be needed. Depends on the individual EA
      upl+= (OrderProfit() + OrderSwap() + OrderCommission()); 
      //The next line of code calculates the pips upl of an open trade. As yet, I have done nothing with it.
      //something = CalculateTradeProfitInPips()
      
      //Trade types
      if (OrderType() == OP_BUY) BuyOpen = true;
      if (OrderType() == OP_SELL) SellOpen = true;
      //Add missing tp/sl in case rapidly moving markets prevent their addition - ECN
      if (OrderStopLoss() == 0 && (StopLoss > 0 ||UseLastColorChangeSL)) InsertStopLoss(TicketNo);
      if (OrderTakeProfit() == 0 && TakeProfit > 0) InsertTakeProfit(TicketNo);
      
      //Check for possible trade closure and order management. Only if hedging and Recovery are not in progress.
      //Extra code will be needed if Caterpillar is being used. As coded, Cat and Recovery are not compatible - it must
      //be one or the other
      if ( (type == OP_BUY || type == OP_SELL) )
      {
         if (UseCloseOnColorChange ||UseCloseOnMACross) 
         {
            TradeWasClosed = LookForTradeClosure(OrderTicket() );
            if (TradeWasClosed) 
            {
               if (type == OP_BUY) BuyOpen = false;//Will be reset if subsequent trades are buys that are not closed
               if (type == OP_SELL) SellOpen = false;//Will be reset if subsequent trades are sells that are not closed
               cc++;
            }//if (TradeWasClosed) 
            
         }//if (HiddenPips > 0) 
         
         if (OrderProfit() > 0 && !TradeWasClosed) TradeManagementModule();
      }//if (!HedgingInProgress && !RecoveryInProgress && (type == OP_BUY || type == OP_SELL) )
      
   }//for (int cc = OrdersTotal() - 1; cc <= 0; c`c--)
   
}//End void CountOpenTrades();

void InsertStopLoss(int ticket)
{
   //Inserts a stop loss if the ECN crim managed to swindle the original trade out of the modification at trade send time
   //Called from CountOpenTrades() if StopLoss > 0 && OrderStopLoss() == 0.
   
   while(IsTradeContextBusy()) Sleep(100);
   if (!OrderSelect(ticket, SELECT_BY_TICKET) || OrderCloseTime() > 0) return;
   
   double stop;
   
   if (OrderType() == OP_BUY)
   {
      stop = CalculateStopLoss(OP_BUY);
   }//if (OrderType() == OP_BUY)
   
   if (OrderType() == OP_SELL)
   {
      stop = CalculateStopLoss(OP_SELL);
   }//if (OrderType() == OP_SELL)
   

   _OrderModify(ticket, OrderOpenPrice(), stop, OrderTakeProfit(), OrderExpiration(), CLR_NONE);

}//End void InsertStopLoss(int ticket)

void InsertTakeProfit(int ticket)
{
   //Inserts a TP if the ECN crim managed to swindle the original trade out of the modification at trade send time
   //Called from CountOpenTrades() if TakeProfit > 0 && OrderTakeProfit() == 0.
   
   while(IsTradeContextBusy()) Sleep(100);
   if (!OrderSelect(ticket, SELECT_BY_TICKET) || OrderCloseTime() > 0) return;
   
   double take;
   
   if (OrderType() == OP_BUY)
   {
      take = CalculateTakeProfit(OP_BUY);
   }//if (OrderType() == OP_BUY)
   
   if (OrderType() == OP_SELL)
   {
      take = CalculateTakeProfit(OP_SELL);
   }//if (OrderType() == OP_SELL)
   

   _OrderModify(ticket, OrderOpenPrice(), OrderStopLoss(), take, OrderExpiration(), CLR_NONE);

}//End void InsertStopLoss(int ticket)

/////////////////////////////////////////////////////////////////////////
// 
// Replace internal functions with updated ones to use trade semaphores
//
/////////////////////////////////////////////////////////////////////////
int _OrderSend(string symbol, int cmd, double volume, double price, int slippage, double stoploss, double takeprofit, string comment="", int magic=0, datetime expiration=0, color arrow_color=CLR_NONE) {

   int res = -1;
   
   //try to lock resource
   if (LockTradingThread()<0) {
      Alert("Unable to place trade, timeout exceeded.");
      return(res);
   }
   RefreshRates();

   //place trade
   res = OrderSend(symbol, cmd, volume, price, slippage, stoploss, takeprofit, comment, magic, expiration, arrow_color);
   
   //unlock resource
   UnlockTradingThread();
   return(res);
}

bool _OrderModify( int ticket, double price, double stoploss, double takeprofit, datetime expiration, color arrow_color=CLR_NONE) {

   bool res = false;
   
   //try to lock resource
   if (LockTradingThread()<0) {
      Alert("Unable to modify trade, timeout exceeded.");
      return(res);
   }
   RefreshRates();
   
   //modify order
   res = OrderModify(ticket, price, stoploss, takeprofit, expiration, arrow_color);
   
   //unlock resource
   UnlockTradingThread();
   return(res);
}

/////////////////////////////////////////////////////////////////////////////////
// int LockTradingThread( int MaxWaiting_sec = 30 )
//
// The function replaces the LockTradingThread value 0 with 1.
// If LockTradingThread = 1 at the moment of launch, the function waits until LockTradingThread is 0, 
// and then replaces.
// If there is no global variable LockTradingThread, the function creates it.
// Return codes:
//  1 - successfully completed. The global variable LockTradingThread was assigned with value 1
// -1 - LockTradingThread = 1 at the moment of launch of the function, the waiting was interrupted by the user
//      (the expert was removed from the chart, the terminal was closed, the chart period and/or symbol 
//      was changed, etc.)
// -2 - LockTradingThread = 1 at the moment of launch of the function, the waiting limit was exceeded
//      (MaxWaiting_sec)
/////////////////////////////////////////////////////////////////////////////////
int LockTradingThread( int MaxWaiting_sec = 60 )
{
   // at testing, there is no resaon to divide the trade context - just terminate 
   // the function
   if(IsTesting()) return(1);
    
   int _GetLastError = 0, StartWaitingTime = GetTickCount();
   //+------------------------------------------------------------------+
   //| Check whether a global variable exists and, if not, create it    |
   //+------------------------------------------------------------------+
   while(true)
   {
      // if the expert was terminated by the user, stop operation
      if(IsStopped()) 
      { 
         Print("The expert was terminated by the user!"); 
         return(-1); 
      }
      // if the waiting time exceeds that specified in the variable 
      // MaxWaiting_sec, stop operation, as well
      if(GetTickCount() - StartWaitingTime > MaxWaiting_sec * 1000)
      {
         Print("Waiting time (" + MaxWaiting_sec + " sec) exceeded!");
         return(-2);
      }
      // check whether the global variable exists
      // if it does, leave the loop and go to the block of changing 
      // LockTradingThread value
      if(GlobalVariableCheck( "LockTradingThread" )) 
         break;
      else
      // if the GlobalVariableCheck returns FALSE, it means that it does not exist or  
      // an error has occurred during checking
      {
         _GetLastError = GetLastError();
         // if it is still an error, display information, wait for 0.1 second, and 
         // restart checking
         if(_GetLastError != 0)
         {
            Print("LockTradingThread()-GlobalVariableCheck(\"LockTradingThread\")-Error #",
                    _GetLastError );
            Sleep(100);
            continue;
         }
      }
      // if there is no error, it means that there is just no global variable, try to create
      // it
      // if the GlobalVariableSet > 0, it means that the global variable has been successfully created. 
      // Leave the function
      if(GlobalVariableSet( "LockTradingThread", 1.0 ) > 0 ) 
         return(1);
      else
      // if the GlobalVariableSet has returned a value <= 0, it means that an error 
      // occurred at creation of the variable
      {
         _GetLastError = GetLastError();
         // display information, wait for 0.1 second, and try again
         if(_GetLastError != 0)
         {
            Print("LockTradingThread()-GlobalVariableSet(\"LockTradingThread\",0.0 )-Error #",
                    _GetLastError );
            Sleep(100);
            continue;
         }
      }
   }
   //+----------------------------------------------------------------------------------+
   //| If the function execution has reached this point, it means that global variable  | 
   //| variable exists.                                                                 |
   //| Wait until the LockTradingThread becomes = 0 and change the value of LockTradingThread for 1 |
   //+----------------------------------------------------------------------------------+
   while(true)
   {
      // if the expert was terminated by the user, stop operation
      if(IsStopped()) 
      { 
         Print("The expert was terminated by the user!"); 
         return(-1); 
      }
      // if the waiting time exceeds that specified in the variable 
      // MaxWaiting_sec, stop operation, as well
      if(GetTickCount() - StartWaitingTime > MaxWaiting_sec * 1000)
      {
         Print("The waiting time (" + MaxWaiting_sec + " sec) exceeded!");
         return(-2);
      }
      // try to change the value of the LockTradingThread from 0 to 1
      // if succeed, leave the function returning 1 ("successfully completed")
      if(GlobalVariableSetOnCondition( "LockTradingThread", 1.0, 0.0 )) 
         return(1);
      else
      // if not, 2 reasons for it are possible: LockTradingThread = 1 (then one has to wait), or 

      // an error occurred (this is what we will check)
      {
         _GetLastError = GetLastError();
         // if it is still an error, display information and try again
         if(_GetLastError != 0)
         {
            Print("LockTradingThread()-GlobalVariableSetOnCondition(\"LockTradingThread\",1.0,0.0 )-Error #",
            _GetLastError );
            continue;
         }
      }
      //if there is no error, it means that LockTradingThread = 1 (another expert is trading), then display 
      // information and wait...
      Print("Wait until another expert finishes trading...");
      Sleep(1000);
   }
}

/////////////////////////////////////////////////////////////////////////////////
// void UnlockTradingThread()
//
// The function sets the value of the global variable LockTradingThread = 0.
// If the LockTradingThread does not exist, the function creates it.
/////////////////////////////////////////////////////////////////////////////////
void UnlockTradingThread()
{
   int _GetLastError;
   // at testing, there is no sense to divide the trade context - just terminate 
   // the function
   if(IsTesting()) 
   { 
      return(0); 
   }
   while(true)
   {
      // if the expert was terminated by the user, ?????????? ??????
      if(IsStopped()) 
      { 
         Print("The expert was terminated by the user!"); 
         return(-1); 
      }
      // try to set the global variable value = 0 (or create the global 
      // variable)
      // if the GlobalVariableSet returns a value > 0, it means that everything 
      // has succeeded. Leave the function
      if(GlobalVariableSet( "LockTradingThread", 0.0 ) > 0) 
         return(1);
      else
      // if the GlobalVariableSet returns a value <= 0, this means that an error has occurred. 
      // Display information, wait, and try again
      {
         _GetLastError = GetLastError();
         if(_GetLastError != 0 )
            Print("UnlockTradingThread()-GlobalVariableSet(\"LockTradingThread\",0.0)-Error #", 
                 _GetLastError );
      }
      Sleep(100);
   }
}

int _AutoMagicNumber(string sSymbol="",int iPeriod=0)
{

  return( iMakeHash(sSymbol,DoubleToStr(iPeriod,0),WindowExpertName()) );

}//_AutoMagicNumber()

//+------------------------------------------------------------------+
//
int iMakeHash (string s1, string s2="", string s3="", string s4="", string s5=""
			      ,string s6="", string s7="", string s8="", string s9="", string s10="")
{
  /*
  Produce 32bit int hash code from  a string composed of up to TEN concatenated input strings.
  WebRef: http://www.cse.yorku.ca/~oz/hash.html
  KeyWrd: "djb2"
  FirstParaOnPage:
  "  Hash Functions
  A comprehensive collection of hash functions, a hash visualiser and some test results [see Mckenzie
  et al. Selecting a Hashing Algorithm, SP&E 20(2):209-224, Feb 1990] will be available someday. If
  you just want to have a good hash function, and cannot wait, djb2 is one of the best string hash
  functions i know. it has excellent distribution and speed on many different sets of keys and table
  sizes. you are not likely to do better with one of the "well known" functions such as PJW, K&R[1],
  etc. Also see tpop pp. 126 for graphing hash functions.
  "

  NOTES: 
  0. WARNING - mql4 strings maxlen=255 so... unless code changed to deal with up to 10 string parameters
     the total length of contactenated string must be <=255
  1. C source uses "unsigned [char|long]", not in MQL4 syntax
  2. When you hash a value, you cannot 'unhash' it. Hashing is a one-way process.
     Using traditional symetric encryption techniques (such as Triple-DES) provide the reversible encryption behaviour you require.
     Ref:http://forums.asp.net/t/886426.aspx subj:Unhash password when using NT Security poster:Participant
  //
  Downside?
  original code uses UNSIGNED - MQL4 not support this, presume could use type double and then cast back to type int.
*/
  string s = StringConcatenate(s1,s2,s3,s4,s5,s6,s7,s8,s9,s10);
  int iHash = 5381;
  int iLast = StringLen(s)-1;
  int iPos=0;

  while( iPos <= iLast )		//while (c = *str++)	[ consume str bytes until EOS hit {myWord! isn't C concise! Pity MQL4 is"!"} ]
  {
    //original C code: hash = ((hash << 5) + hash) + c; /* hash * 33 + c */
    iHash = ((iHash << 5) + iHash) + StringGetChar(s,iPos);		//StringGetChar() returns int
    iPos++;
  }
  return(MathAbs(iHash));
}//iMakeHash()

////////////////////////////////////////////////////////////////////////////////////
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----

   if (OpenTrades == 0)
   {
      TicketNo = -1;
      ForceTradeClosure = false;
   }//if (OrdersTotal() == 0)

   if (ForceTradeClosure) 
   {
      CloseAllTrades();
      return;
   }//if (ForceTradeClosure) 
     
   //Daily results so far - they work on what in in the history tab, so users need warning that
   //what they see displayed on screen depends on that.   
   static int OldHistoryTotal;
   if (OrdersHistoryTotal() != OldHistoryTotal)
   {
      CalculateDailyResult();//Does no harm to have a recalc from time to time
      OldHistoryTotal = OrdersHistoryTotal();
   }//if (OrdersHistoryTotal() != OldHistoryTotal)
      
   ReadIndicatorValues();
   
   ///////////////////////////////////////////////////////////////////////////////////////////////
   //Find open trades.
   CountOpenTrades();
 
   ///////////////////////////////////////////////////////////////////////////////////////////////         
   //Trading
   if (OldBars != iBars(Symbol(),RenkoTF))
   {
      OldBars = iBars(Symbol(),RenkoTF);  
         
      if (!StopTrading && (UseGrid || (!UseGrid && TicketNo == -1 && OpenTrades == 0)))
      {
         LookForTradingOpportunities();
      }
   }
   DisplayUserFeedback();
   
//----
   return(0);
}
//+------------------------------------------------------------------+

